package info.textgrid.lab.feedback.ui.bugreport2;

import info.textgrid.lab.feedback.ui.Activator;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.nio.charset.Charset;
import java.util.List;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.SubMonitor;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.osgi.util.NLS;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.ExpandBar;
import org.eclipse.swt.widgets.ExpandItem;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.statushandlers.StatusManager;
import org.eclipse.wb.swt.ResourceManager;

import com.google.common.base.Joiner;
import com.google.common.collect.Lists;
import com.google.common.io.Files;

public class BugDataPage extends WizardPage {
	private final class SaveGeneratedStuffHandler extends SelectionAdapter {
		@Override
		public void widgetSelected(final SelectionEvent e) {
			saveGeneratedStuff();
		}
	}

	protected Text logFile;
	protected Text configurationData;
	private Text text;
	private boolean reportDetails = true;
	private final List<File> files = Lists.newArrayList();
	Button saveLogButton;


	public List<File> getFiles() {
		return files;
	}

	/**
	 * Create the wizard.
	 */
	public BugDataPage() {
		super(Messages.BugDataPage_PageTitle);
		setTitle(Messages.BugDataPage_this_title);
		setDescription(Messages.BugDataPage_this_description);
	}

	void saveGeneratedStuff() {
		final FileDialog saveDialog = new FileDialog(getShell(), SWT.SAVE);
		saveDialog.setText(Messages.BugDataPage_Save_generated_files);
		saveDialog.setFileName("textgridlab.log"); //$NON-NLS-1$
		if (saveDialog.open() != null) {
			final File logFile = new File(saveDialog.getFilterPath(), saveDialog.getFileName());
			final String logPath = logFile.getPath();
			final String ext = Files.getFileExtension(logPath);
			final File cfgFile = new File(logPath.substring(0, logPath.length() - ext.length()).concat("cfg")); //$NON-NLS-1$
			final String logData = BugDataPage.this.logFile.getText();
			final String configData = configurationData.getText();
			try {
				getContainer().run(true, false, new IRunnableWithProgress() {
	
					@Override
					public void run(final IProgressMonitor monitor) throws InvocationTargetException,
							InterruptedException {
						final SubMonitor progress = SubMonitor.convert(monitor, Messages.BugDataPage_SavingFiles, 2);
						try {
							Files.write(logData, logFile, Charset.forName("UTF-8")); //$NON-NLS-1$
							progress.worked(1);
							if (progress.isCanceled())
								throw new InterruptedException();
							Files.write(configData, cfgFile, Charset.forName("UTF-8")); //$NON-NLS-1$
							progress.worked(1);
						} catch (final IOException e) {
							throw new InvocationTargetException(e);
						}
					}
				});
				setMessage(NLS.bind(Messages.BugDataPage_LogDataWrittenTo, logFile, cfgFile));
			} catch (final InvocationTargetException e1) {
				final String msg = NLS.bind(Messages.BugDataPage_ErrorSavingFiles, e1.getCause().getLocalizedMessage());
				setMessage(msg, ERROR);
				StatusManager.getManager().handle(new Status(IStatus.ERROR, Activator.PLUGIN_ID, msg, e1.getCause()));
			} catch (final InterruptedException e1) {
				// Canceled -- nothing to do
			}
		}
	}

	/**
	 * Create contents of the wizard.
	 * @param parent
	 */
	@Override
	public void createControl(final Composite parent) {
		final Composite container = new Composite(parent, SWT.NULL);

		setControl(container);
		container.setLayout(new GridLayout(1, false));

		setPageComplete(false);

		final Group grpAutogeneratedDetails = new Group(container, SWT.NONE);
		grpAutogeneratedDetails.setText(Messages.BugDataPage_grpAutogeneratedDetails_text);
		final GridData gd_grpAutogeneratedDetails = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_grpAutogeneratedDetails.widthHint = 400;
		grpAutogeneratedDetails.setLayoutData(gd_grpAutogeneratedDetails);
		grpAutogeneratedDetails.setLayout(new GridLayout(1, false));

		final ScrolledComposite scrolledComposite = new ScrolledComposite(grpAutogeneratedDetails, SWT.BORDER | SWT.V_SCROLL);
		scrolledComposite.setExpandVertical(true);
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setShowFocusedControl(true);
		scrolledComposite.setAlwaysShowScrollBars(true);
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		final Composite composite = new Composite(scrolledComposite, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));

		final Label lblNewLabel = new Label(composite, SWT.WRAP);
		lblNewLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1));
		lblNewLabel.setText(Messages.BugDataPage_lblNewLabel_text);
		final Composite composite_1 = new Composite(composite, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		final GridLayout composite_1GridLayout = new GridLayout(2, false);
		composite_1GridLayout.marginHeight = 0;
		composite_1GridLayout.marginWidth = 0;
		composite_1.setLayout(composite_1GridLayout);

				final Button btnCheckButton = new Button(composite_1, SWT.CHECK);
				btnCheckButton.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
				btnCheckButton.addSelectionListener(new SelectionAdapter() {

					@Override
					public void widgetSelected(final SelectionEvent e) {
						if (btnCheckButton.getSelection()) {
							setMessage(null, WARNING);
							reportDetails = true;
						} else {
							setMessage(Messages.BugDataPage_AttachLabel, WARNING);
							reportDetails = false;
						}
					}
				});
				btnCheckButton.setSelection(true);
				btnCheckButton.setText(Messages.BugDataPage_btnCheckButton_text);
				saveLogButton = new Button(composite_1, SWT.FLAT | SWT.RIGHT);
				saveLogButton.addSelectionListener(new SaveGeneratedStuffHandler());
				saveLogButton.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
				saveLogButton.setToolTipText(Messages.BugDataPage_saveLogButton_toolTipText);
				saveLogButton.setImage(ResourceManager.getPluginImage("org.eclipse.ui", "/icons/full/etool16/saveall_edit.gif")); //$NON-NLS-1$ //$NON-NLS-2$
				saveLogButton.setText(""); //$NON-NLS-1$

		final ExpandBar expandBar = new ExpandBar(composite, SWT.NONE);
		expandBar.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		final ExpandItem logFileXE = new ExpandItem(expandBar, SWT.NONE);
		logFileXE.setText(Messages.BugDataPage_xpndtmNewExpanditem_text);

		logFile = new Text(expandBar, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		logFile.setText(Messages.BugDataPage_logFile_text);
		logFileXE.setControl(logFile);
		logFileXE.setHeight(200);

		final ExpandItem configurationDetailsXE = new ExpandItem(expandBar, SWT.NONE);
		configurationDetailsXE.setText(Messages.BugDataPage_xpndtmNewExpanditem_1_text);

		configurationData = new Text(expandBar, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL | SWT.CANCEL | SWT.MULTI);
		configurationData.setText(Messages.BugDataPage_logFile_text);
		configurationDetailsXE.setControl(configurationData);
		configurationDetailsXE.setHeight(200);
		new Label(composite, SWT.NONE);
		scrolledComposite.setMinSize(new Point(0, 0));
		scrolledComposite.setContent(composite);

		final Group grpAttachments = new Group(container, SWT.NONE);
		grpAttachments.setText(Messages.BugDataPage_grpAttachments_text);
		grpAttachments.setLayout(new GridLayout(2, false));
		final GridData gd_grpAttachments = new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1);
		gd_grpAttachments.widthHint = 400;
		grpAttachments.setLayoutData(gd_grpAttachments);

		final Label lblNewLabel_1 = new Label(grpAttachments, SWT.NONE);
		lblNewLabel_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		lblNewLabel_1.setText(Messages.BugDataPage_lblNewLabel_1_text);

		text = new Text(grpAttachments, SWT.BORDER | SWT.READ_ONLY | SWT.SEARCH | SWT.CANCEL);
		text.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetDefaultSelected(final SelectionEvent e) {
				if ((e.detail & SWT.ICON_CANCEL) != 0) {
					files.clear();
				}
			}
		});
		text.setEditable(false);
		text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		final Button btnNewButton = new Button(grpAttachments, SWT.NONE);
		btnNewButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(final SelectionEvent e) {
				final FileDialog fileDialog = new FileDialog(getShell(), SWT.MULTI | SWT.OPEN);
				fileDialog.setText(Messages.BugDataPage_AttachTitle);
				if (fileDialog.getFilterPath() == null || fileDialog.getFilterPath().isEmpty())
					fileDialog.setFilterPath(System.getProperty("user.home", "/")); //$NON-NLS-1$ //$NON-NLS-2$
				if (fileDialog.open() != null) {
					files.clear();
					for (final String filename : fileDialog.getFileNames()) {
						files.add(new File(fileDialog.getFilterPath(), filename));
					}
				}
				text.setText(Joiner.on(", ").join(fileDialog.getFileNames())); //$NON-NLS-1$
			}
		});
		btnNewButton.setText(Messages.BugDataPage_btnNewButton_text);


	}

	public void setSummary(final String systemSummary, final String systemLog) {
		logFile.setText(systemLog);
		configurationData.setText(systemSummary);
		setPageComplete(true);
	}

	private File getTempFile(final Text text) throws IOException {
		if (text.isDisposed())
			return null;
		else if (reportDetails && !text.getText().isEmpty()) {
			final File file = File.createTempFile("textgridlab", ".log"); //$NON-NLS-1$ //$NON-NLS-2$
			file.deleteOnExit();
			Files.write(text.getText(), file, Charset.forName("UTF-8")); //$NON-NLS-1$
			return file;
		}
		else return null;
	}

	public File getTempLogFile() throws IOException {
		return getTempFile(logFile);
	}

	public File getTempConfFile() throws IOException {
		return getTempFile(configurationData);
	}
}
